import json
from json import JSONEncoder
from inspect import ismethod, isfunction, isbuiltin, isabstract

def multiDict2Dict(md):
	ns = {}
	for k,v in md.items():
		ov = ns.get(k,None)
		if ov is None:
			ns[k] = v
		elif type(ov) == type([]):
			ov.append(v)
			ns[k] = ov
		else:
			ns[k] = [ov,v]
	return ns

class DictObjectEncoder(JSONEncoder):
	def default(self, o):
		return o._addon()

class DictObject(dict):
	def __getattr__(self, attr):
		"""
		实现点操作符访问字典中的键值对
		"""
		try:
			return self.__DOitem(self[attr])
		except KeyError:
			return None

	def __getitem__(self, key):
		v = super().__getitem__(key)
		return self.__DOitem(v)

	def __setattr__(self, attr, value):
		"""
		实现点操作符设置字典中的键值对
		"""
		self[attr] = value

	def copy(self):
		return self.__DOitem(super().copy())

	@classmethod
	def isMe(self,name):
		return name == 'DictObject'

	def to_dict(self):
		return self

	def __DOArray(self,a):
		b = [ self.__DOitem(i) for i in a ]
		return b
	
	def __DOitem(self, i):
		if isinstance(i,DictObject):
			return i
		if isinstance(i,dict):
			i = {k:v for k,v in i.items() if isinstance(k,str)}
			try:
				d = DictObject(**i)
				return d
			except Exception as e:
				raise e
		if type(i) == type([]) or type(i) == type(()) :
			return self.__DOArray(i)
		return i

def dictObjectFactory(_klassName__,**kwargs):
	def findSubclass(_klassName__,klass):
		for k in klass.__subclasses__():
			if k.isMe(_klassName__):
				return k
			k1 = findSubclass(_klassName__,k)
			if k1 is not None:
				return k1
		return None
	try:
		if _klassName__=='DictObject':
			return DictObject(**kwargs)
		k = findSubclass(_klassName__,DictObject)
		if k is None:
			return DictObject(**kwargs)
		return k(**kwargs)
	except Exception as e:
		print("dictObjectFactory()",e,_klassName__)
		raise e

